unit FreeOTFEfmeOptions_AutoRun;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FreeOTFEfmeOptions_Base, StdCtrls;

type
  TfmeOptions_Autorun = class(TfmeOptions_Base)
    gbAutorun: TGroupBox;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    edPostMountExe: TEdit;
    pbPostMountBrowse: TButton;
    pbPreDismountBrowse: TButton;
    edPreDismountExe: TEdit;
    pbPostDismountBrowse: TButton;
    edPostDismountExe: TEdit;
    ckPrePostExeWarn: TCheckBox;
    OpenDialog: TOpenDialog;
    procedure FrameResize(Sender: TObject);
    procedure pbPostMountBrowseClick(Sender: TObject);
    procedure pbPreDismountBrowseClick(Sender: TObject);
    procedure pbPostDismountBrowseClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure ReadSettings(); override;
    procedure WriteSettings(); override;
  end;

implementation

{$R *.dfm}

uses
  SDUGeneral,
  FreeOTFESettings;

const
  FILTER_EXECUTABLE_FILES = 'Program files (*.exe, *.com, *.bat)|*.exe; *.bat; *.com|All files|*.*';

procedure TfmeOptions_Autorun.FrameResize(Sender: TObject);
begin
  SDUCenterControl(gbAutorun, ccHorizontal);
  SDUCenterControl(gbAutorun, ccVertical, 25);
end;

procedure TfmeOptions_Autorun.pbPostMountBrowseClick(Sender: TObject);
begin
  inherited;
  OpenDialog.title := 'Locate post mount executable';
  OpenDialog.Filter := FILTER_EXECUTABLE_FILES;
  SDUOpenSaveDialogSetup(OpenDialog, edPostMountExe.text);
  if (OpenDialog.execute) then
    begin
    // Strip drive letter
    edPostMountExe.text := copy(OpenDialog.Filename, 3, length(OpenDialog.Filename)-2);
    end;

end;

procedure TfmeOptions_Autorun.pbPreDismountBrowseClick(Sender: TObject);
begin
  inherited;
  OpenDialog.title := 'Locate pre dismount executable';
  OpenDialog.Filter := FILTER_EXECUTABLE_FILES;
  SDUOpenSaveDialogSetup(OpenDialog, edPreDismountExe.text);
  if (OpenDialog.execute) then
    begin
    // Strip drive letter
    edPreDismountExe.text := copy(OpenDialog.Filename, 3, length(OpenDialog.Filename)-2);
    end;

end;

procedure TfmeOptions_Autorun.pbPostDismountBrowseClick(Sender: TObject);
begin
  inherited;
  OpenDialog.title := 'Locate post dismount executable';
  OpenDialog.Filter := FILTER_EXECUTABLE_FILES;
  SDUOpenSaveDialogSetup(OpenDialog, edPostDismountExe.text);
  if (OpenDialog.execute) then
    begin
    edPostDismountExe.text := OpenDialog.Filename;
    end;

end;

procedure TfmeOptions_Autorun.ReadSettings();
begin
  edPostMountExe.text    := Settings.OptPostMountExe;
  edPreDismountExe.text  := Settings.OptPreDismountExe;
  edPostDismountExe.text := Settings.OptPostDismountExe;

  ckPrePostExeWarn.checked := Settings.OptPrePostExeWarn;

end;

procedure TfmeOptions_Autorun.WriteSettings();
begin
  Settings.OptPostMountExe := edPostMountExe.text;
  Settings.OptPreDismountExe := edPreDismountExe.text;
  Settings.OptPostDismountExe := edPostDismountExe.text;

  Settings.OptPrePostExeWarn := ckPrePostExeWarn.checked;

end;

END.

